Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/ZDF/zdfosm.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/ZDF/zdfosm.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/ZDF/zdfosm.F90	(revision 12928)
@@ -49,5 +49,5 @@
    !!----------------------------------------------------------------------
    USE oce            ! ocean dynamics and active tracers
-                      ! uses wn from previous time step (which is now wb) to calculate hbl
+                      ! uses ww from previous time step (which is now wb) to calculate hbl
    USE dom_oce        ! ocean space and time domain
    USE zdf_oce        ! ocean vertical physics
@@ -139,7 +139,9 @@
    INTEGER :: idebug = 236
    INTEGER :: jdebug = 228
+   !! * Substitutions
+#  include "do_loop_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
-   !! $Id: zdfosm.F90 12317 2020-01-14 12:40:47Z agn $
+   !! $Id$
    !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
@@ -171,5 +173,5 @@
 
 
-   SUBROUTINE zdf_osm( kt, p_avm, p_avt )
+   SUBROUTINE zdf_osm( kt, Kbb, Kmm, Krhs, p_avm, p_avt )
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE zdf_osm  ***
@@ -206,5 +208,6 @@
       !!         the equation number. (LMD94, here after)
       !!----------------------------------------------------------------------
-      INTEGER                   , INTENT(in   ) ::   kt            ! ocean time step
+      INTEGER                   , INTENT(in   ) ::  kt             ! ocean time step
+      INTEGER                   , INTENT(in   ) ::  Kbb, Kmm, Krhs ! ocean time level indices
       REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::  p_avm, p_avt   ! momentum and tracer Kz (w-points)
       !!
@@ -378,104 +381,92 @@
      zz0 =       rn_abs       ! surface equi-partition in 2-bands
      zz1 =  1. - rn_abs
-     DO jj = 2, jpjm1
-        DO ji = 2, jpim1
-           ! Surface downward irradiance (so always +ve)
-           zrad0(ji,jj) = qsr(ji,jj) * r1_rau0_rcp
-           ! Downwards irradiance at base of boundary layer
-           zradh(ji,jj) = zrad0(ji,jj) * ( zz0 * EXP( -hbl(ji,jj)/rn_si0 ) + zz1 * EXP( -hbl(ji,jj)/rn_si1) )
-           ! Downwards irradiance averaged over depth of the OSBL
-           zradav(ji,jj) = zrad0(ji,jj) * ( zz0 * ( 1.0 - EXP( -hbl(ji,jj)/rn_si0 ) )*rn_si0 &
-                 &                         + zz1 * ( 1.0 - EXP( -hbl(ji,jj)/rn_si1 ) )*rn_si1 ) / hbl(ji,jj)
-        END DO
-     END DO
+     DO_2D_00_00
+        ! Surface downward irradiance (so always +ve)
+        zrad0(ji,jj) = qsr(ji,jj) * r1_rho0_rcp
+        ! Downwards irradiance at base of boundary layer
+        zradh(ji,jj) = zrad0(ji,jj) * ( zz0 * EXP( -hbl(ji,jj)/rn_si0 ) + zz1 * EXP( -hbl(ji,jj)/rn_si1) )
+        ! Downwards irradiance averaged over depth of the OSBL
+        zradav(ji,jj) = zrad0(ji,jj) * ( zz0 * ( 1.0 - EXP( -hbl(ji,jj)/rn_si0 ) )*rn_si0 &
+              &                         + zz1 * ( 1.0 - EXP( -hbl(ji,jj)/rn_si1 ) )*rn_si1 ) / hbl(ji,jj)
+     END_2D
      ! Turbulent surface fluxes and fluxes averaged over depth of the OSBL
-     DO jj = 2, jpjm1
-        DO ji = 2, jpim1
-           zthermal = rab_n(ji,jj,1,jp_tem)
-           zbeta    = rab_n(ji,jj,1,jp_sal)
-           ! Upwards surface Temperature flux for non-local term
-           zwth0(ji,jj) = - qns(ji,jj) * r1_rau0_rcp * tmask(ji,jj,1)
-           ! Upwards surface salinity flux for non-local term
-           zws0(ji,jj) = - ( ( emp(ji,jj)-rnf(ji,jj) ) * tsn(ji,jj,1,jp_sal)  + sfx(ji,jj) ) * r1_rau0 * tmask(ji,jj,1)
-           ! Non radiative upwards surface buoyancy flux
-           zwb0(ji,jj) = grav * zthermal * zwth0(ji,jj) -  grav * zbeta * zws0(ji,jj)
-           ! turbulent heat flux averaged over depth of OSBL
-           zwthav(ji,jj) = 0.5 * zwth0(ji,jj) - ( 0.5*( zrad0(ji,jj) + zradh(ji,jj) ) - zradav(ji,jj) )
-           ! turbulent salinity flux averaged over depth of the OBSL
-           zwsav(ji,jj) = 0.5 * zws0(ji,jj)
-           ! turbulent buoyancy flux averaged over the depth of the OBSBL
-           zwbav(ji,jj) = grav  * zthermal * zwthav(ji,jj) - grav  * zbeta * zwsav(ji,jj)
-           ! Surface upward velocity fluxes
-           zuw0(ji,jj) = -utau(ji,jj) * r1_rau0 * tmask(ji,jj,1)
-           zvw0(ji,jj) = -vtau(ji,jj) * r1_rau0 * tmask(ji,jj,1)
-           ! Friction velocity (zustar), at T-point : LMD94 eq. 2
-           zustar(ji,jj) = MAX( SQRT( SQRT( zuw0(ji,jj) * zuw0(ji,jj) + zvw0(ji,jj) * zvw0(ji,jj) ) ), 1.0e-8 )
-           zcos_wind(ji,jj) = -zuw0(ji,jj) / ( zustar(ji,jj) * zustar(ji,jj) )
-           zsin_wind(ji,jj) = -zvw0(ji,jj) / ( zustar(ji,jj) * zustar(ji,jj) )
-        END DO
-     END DO
+     DO_2D_00_00
+        zthermal = rab_n(ji,jj,1,jp_tem)
+        zbeta    = rab_n(ji,jj,1,jp_sal)
+        ! Upwards surface Temperature flux for non-local term
+        zwth0(ji,jj) = - qns(ji,jj) * r1_rho0_rcp * tmask(ji,jj,1)
+        ! Upwards surface salinity flux for non-local term
+        zws0(ji,jj) = - ( ( emp(ji,jj)-rnf(ji,jj) ) * ts(ji,jj,1,jp_sal,Kmm)  + sfx(ji,jj) ) * r1_rho0 * tmask(ji,jj,1)
+        ! Non radiative upwards surface buoyancy flux
+        zwb0(ji,jj) = grav * zthermal * zwth0(ji,jj) -  grav * zbeta * zws0(ji,jj)
+        ! turbulent heat flux averaged over depth of OSBL
+        zwthav(ji,jj) = 0.5 * zwth0(ji,jj) - ( 0.5*( zrad0(ji,jj) + zradh(ji,jj) ) - zradav(ji,jj) )
+        ! turbulent salinity flux averaged over depth of the OBSL
+        zwsav(ji,jj) = 0.5 * zws0(ji,jj)
+        ! turbulent buoyancy flux averaged over the depth of the OBSBL
+        zwbav(ji,jj) = grav  * zthermal * zwthav(ji,jj) - grav  * zbeta * zwsav(ji,jj)
+        ! Surface upward velocity fluxes
+        zuw0(ji,jj) = -utau(ji,jj) * r1_rho0 * tmask(ji,jj,1)
+        zvw0(ji,jj) = -vtau(ji,jj) * r1_rho0 * tmask(ji,jj,1)
+        ! Friction velocity (zustar), at T-point : LMD94 eq. 2
+        zustar(ji,jj) = MAX( SQRT( SQRT( zuw0(ji,jj) * zuw0(ji,jj) + zvw0(ji,jj) * zvw0(ji,jj) ) ), 1.0e-8 )
+        zcos_wind(ji,jj) = -zuw0(ji,jj) / ( zustar(ji,jj) * zustar(ji,jj) )
+        zsin_wind(ji,jj) = -zvw0(ji,jj) / ( zustar(ji,jj) * zustar(ji,jj) )
+     END_2D
      ! Calculate Stokes drift in direction of wind (zustke) and Stokes penetration depth (dstokes)
      SELECT CASE (nn_osm_wave)
      ! Assume constant La#=0.3
      CASE(0)
-        DO jj = 2, jpjm1
-           DO ji = 2, jpim1
-              zus_x = zcos_wind(ji,jj) * zustar(ji,jj) / 0.3**2
-              zus_y = zsin_wind(ji,jj) * zustar(ji,jj) / 0.3**2
-              zustke(ji,jj) = MAX ( SQRT( zus_x*zus_x + zus_y*zus_y), 1.0e-8 )
-              ! dstokes(ji,jj) set to constant value rn_osm_dstokes from namelist in zdf_osm_init
-           END DO
-        END DO
+        DO_2D_00_00
+           zus_x = zcos_wind(ji,jj) * zustar(ji,jj) / 0.3**2
+           zus_y = zsin_wind(ji,jj) * zustar(ji,jj) / 0.3**2
+           zustke(ji,jj) = MAX ( SQRT( zus_x*zus_x + zus_y*zus_y), 1.0e-8 )
+           ! dstokes(ji,jj) set to constant value rn_osm_dstokes from namelist in zdf_osm_init
+        END_2D
      ! Assume Pierson-Moskovitz wind-wave spectrum
      CASE(1)
-        DO jj = 2, jpjm1
-           DO ji = 2, jpim1
-              ! Use wind speed wndm included in sbc_oce module
-              zustke(ji,jj) = MAX ( 0.016 * wndm(ji,jj), 1.0e-8 )
-              dstokes(ji,jj) = MAX( 0.12 * wndm(ji,jj)**2 / grav, 5.e-1)
-           END DO
-        END DO
+        DO_2D_00_00
+           ! Use wind speed wndm included in sbc_oce module
+           zustke(ji,jj) = MAX ( 0.016 * wndm(ji,jj), 1.0e-8 )
+           dstokes(ji,jj) = MAX( 0.12 * wndm(ji,jj)**2 / grav, 5.e-1)
+        END_2D
      ! Use ECMWF wave fields as output from SBCWAVE
      CASE(2)
         zfac =  2.0_wp * rpi / 16.0_wp
-        DO jj = 2, jpjm1
-           DO ji = 2, jpim1
-              ! The Langmur number from the ECMWF model appears to give La<0.3 for wind-driven seas.
-              !    The coefficient 0.8 gives La=0.3  in this situation.
-              ! It could represent the effects of the spread of wave directions
-              ! around the mean wind. The effect of this adjustment needs to be tested.
-              zabsstke = SQRT(ut0sd(ji,jj)**2 + vt0sd(ji,jj)**2)
-              zustke(ji,jj) = MAX (0.8 * ( zcos_wind(ji,jj) * ut0sd(ji,jj) + zsin_wind(ji,jj)  * vt0sd(ji,jj) ), 1.0e-8)
-              dstokes(ji,jj) = MAX(zfac * hsw(ji,jj)*hsw(ji,jj) / ( MAX(zabsstke*wmp(ji,jj), 1.0e-7 ) ), 5.0e-1) !rn_osm_dstokes !
-           END DO
-        END DO
+        DO_2D_00_00
+           ! The Langmur number from the ECMWF model appears to give La<0.3 for wind-driven seas.
+           !    The coefficient 0.8 gives La=0.3  in this situation.
+           ! It could represent the effects of the spread of wave directions
+           ! around the mean wind. The effect of this adjustment needs to be tested.
+           zabsstke = SQRT(ut0sd(ji,jj)**2 + vt0sd(ji,jj)**2)
+           zustke(ji,jj) = MAX (0.8 * ( zcos_wind(ji,jj) * ut0sd(ji,jj) + zsin_wind(ji,jj)  * vt0sd(ji,jj) ), 1.0e-8)
+           dstokes(ji,jj) = MAX(zfac * hsw(ji,jj)*hsw(ji,jj) / ( MAX(zabsstke*wmp(ji,jj), 1.0e-7 ) ), 5.0e-1) !rn_osm_dstokes !
+        END_2D
      END SELECT
 
      ! Langmuir velocity scale (zwstrl), La # (zla)
      ! mixed scale (zvstr), convective velocity scale (zwstrc)
-     DO jj = 2, jpjm1
-        DO ji = 2, jpim1
-           ! Langmuir velocity scale (zwstrl), at T-point
-           zwstrl(ji,jj) = ( zustar(ji,jj) * zustar(ji,jj) * zustke(ji,jj) )**pthird
-           zla(ji,jj) = MAX(MIN(SQRT ( zustar(ji,jj) / ( zwstrl(ji,jj) + epsln ) )**3, 4.0), 0.2)
-           IF(zla(ji,jj) > 0.45) dstokes(ji,jj) = MIN(dstokes(ji,jj), 0.5_wp*hbl(ji,jj))
-           ! Velocity scale that tends to zustar for large Langmuir numbers
-           zvstr(ji,jj) = ( zwstrl(ji,jj)**3  + &
-                & ( 1.0 - EXP( -0.5 * zla(ji,jj)**2 ) ) * zustar(ji,jj) * zustar(ji,jj) * zustar(ji,jj) )**pthird
-
-           ! limit maximum value of Langmuir number as approximate treatment for shear turbulence.
-           ! Note zustke and zwstrl are not amended.
-           !
-           ! get convective velocity (zwstrc), stabilty scale (zhol) and logical conection flag lconv
-           IF ( zwbav(ji,jj) > 0.0) THEN
-              zwstrc(ji,jj) = ( 2.0 * zwbav(ji,jj) * 0.9 * hbl(ji,jj) )**pthird
-              zhol(ji,jj) = -0.9 * hbl(ji,jj) * 2.0 * zwbav(ji,jj) / (zvstr(ji,jj)**3 + epsln )
-              lconv(ji,jj) = .TRUE.
-           ELSE
-              zhol(ji,jj) = -hbl(ji,jj) *  2.0 * zwbav(ji,jj)/ (zvstr(ji,jj)**3  + epsln )
-              lconv(ji,jj) = .FALSE.
-           ENDIF
-        END DO
-     END DO
+     DO_2D_00_00
+        ! Langmuir velocity scale (zwstrl), at T-point
+        zwstrl(ji,jj) = ( zustar(ji,jj) * zustar(ji,jj) * zustke(ji,jj) )**pthird
+        zla(ji,jj) = MAX(MIN(SQRT ( zustar(ji,jj) / ( zwstrl(ji,jj) + epsln ) )**3, 4.0), 0.2)
+        IF(zla(ji,jj) > 0.45) dstokes(ji,jj) = MIN(dstokes(ji,jj), 0.5_wp*hbl(ji,jj))
+        ! Velocity scale that tends to zustar for large Langmuir numbers
+        zvstr(ji,jj) = ( zwstrl(ji,jj)**3  + &
+             & ( 1.0 - EXP( -0.5 * zla(ji,jj)**2 ) ) * zustar(ji,jj) * zustar(ji,jj) * zustar(ji,jj) )**pthird
+
+        ! limit maximum value of Langmuir number as approximate treatment for shear turbulence.
+        ! Note zustke and zwstrl are not amended.
+        !
+        ! get convective velocity (zwstrc), stabilty scale (zhol) and logical conection flag lconv
+        IF ( zwbav(ji,jj) > 0.0) THEN
+           zwstrc(ji,jj) = ( 2.0 * zwbav(ji,jj) * 0.9 * hbl(ji,jj) )**pthird
+           zhol(ji,jj) = -0.9 * hbl(ji,jj) * 2.0 * zwbav(ji,jj) / (zvstr(ji,jj)**3 + epsln )
+           lconv(ji,jj) = .TRUE.
+        ELSE
+           zhol(ji,jj) = -hbl(ji,jj) *  2.0 * zwbav(ji,jj)/ (zvstr(ji,jj)**3  + epsln )
+           lconv(ji,jj) = .FALSE.
+        ENDIF
+     END_2D
 
      !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
@@ -486,34 +477,28 @@
      ! zdf_osm_zmld_horizontal_gradients need halo values for ibld, so must
      ! previously exist for hbl also.
-      hbl(:,:) = MAX(hbl(:,:), gdepw_n(:,:,4) )
+      hbl(:,:) = MAX(hbl(:,:), gdepw(:,:,4,Kmm) )
       ibld(:,:) = 4
-      DO jk = 5, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               IF ( hbl(ji,jj) >= gdepw_n(ji,jj,jk) ) THEN
-                  ibld(ji,jj) = MIN(mbkt(ji,jj), jk)
-               ENDIF
-            END DO
-         END DO
-      END DO
-
-      DO jj = 2, jpjm1
-         DO ji = 2, jpim1
-            zhbl(ji,jj) = gdepw_n(ji,jj,ibld(ji,jj))
-            imld(ji,jj) = MAX(3,ibld(ji,jj) - MAX( INT( dh(ji,jj) / e3t_n(ji, jj, ibld(ji,jj) )) , 1 ))
-            zhml(ji,jj) = gdepw_n(ji,jj,imld(ji,jj))
-         END DO
-      END DO
+      DO_3D_11_11( 5, jpkm1 )
+         IF ( hbl(ji,jj) >= gdepw(ji,jj,jk,Kmm) ) THEN
+            ibld(ji,jj) = MIN(mbkt(ji,jj), jk)
+         ENDIF
+      END_3D
+
+      DO_2D_00_00
+         zhbl(ji,jj) = gdepw(ji,jj,ibld(ji,jj),Kmm)
+         imld(ji,jj) = MAX(3,ibld(ji,jj) - MAX( INT( dh(ji,jj) / e3t(ji, jj, ibld(ji,jj), Kmm )) , 1 ))
+         zhml(ji,jj) = gdepw(ji,jj,imld(ji,jj),Kmm)
+      END_2D
       ! Averages over well-mixed and boundary layer
       ! Alan: do we need zb_nl?, zb_ml?
-      CALL zdf_osm_vertical_average(ibld, zt_bl, zs_bl, zu_bl, zv_bl, zdt_bl, zds_bl, zdb_bl, zdu_bl, zdv_bl)
-      CALL zdf_osm_vertical_average(imld, zt_ml, zs_ml, zu_ml, zv_ml, zdt_ml, zds_ml, zdb_ml, zdu_ml, zdv_ml)
+      CALL zdf_osm_vertical_average(ibld, zt_bl, zs_bl, zu_bl, zv_bl, zdt_bl, zds_bl, zdb_bl, zdu_bl, zdv_bl, Kmm, Kbb )
+      CALL zdf_osm_vertical_average(imld, zt_ml, zs_ml, zu_ml, zv_ml, zdt_ml, zds_ml, zdb_ml, zdu_ml, zdv_ml, Kmm, Kbb )
 ! External gradient
-      CALL zdf_osm_external_gradients( zdtdz_ext, zdsdz_ext, zdbdz_ext )
+      CALL zdf_osm_external_gradients( zdtdz_ext, zdsdz_ext, zdbdz_ext, Kmm )
 
 
       IF ( ln_osm_mle ) THEN
-         CALL zdf_osm_zmld_horizontal_gradients( zmld, zdtdx, zdtdy, zdsdx, zdsdy, dbdx_mle, dbdy_mle )
-         CALL zdf_osm_mle_parameters( hmle, zwb_fk, zvel_mle, zdiff_mle )
+         CALL zdf_osm_zmld_horizontal_gradients( zmld, zdtdx, zdtdy, zdsdx, zdsdy, dbdx_mle, dbdy_mle, Kmm )
+         CALL zdf_osm_mle_parameters( hmle, zwb_fk, zvel_mle, zdiff_mle, Kmm )
        ENDIF
 
@@ -521,39 +506,34 @@
       CALL zdf_osm_calculate_dhdt( zdhdt, zdhdt_2 )
       ! Calculate averages over depth of boundary layer
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1
-               zhbl_t(ji,jj) = hbl(ji,jj) + (zdhdt(ji,jj) - wn(ji,jj,ibld(ji,jj)))* rn_rdt ! certainly need wn here, so subtract it
-               ! adjustment to represent limiting by ocean bottom
-               zhbl_t(ji,jj) = MIN(zhbl_t(ji,jj), gdepw_n(ji,jj, mbkt(ji,jj) + 1) - depth_tol)! ht_n(:,:))
-            END DO
-         END DO
+      DO_2D_00_00
+         zhbl_t(ji,jj) = hbl(ji,jj) + (zdhdt(ji,jj) - ww(ji,jj,ibld(ji,jj)))* rn_Dt ! certainly need wn here, so subtract it
+         ! adjustment to represent limiting by ocean bottom
+         zhbl_t(ji,jj) = MIN(zhbl_t(ji,jj), gdepw(ji,jj, mbkt(ji,jj) + 1,Kmm) - depth_tol)! ht_n(:,:))
+      END_2D
 
       imld(:,:) = ibld(:,:)           ! use imld to hold previous blayer index
       ibld(:,:) = 4
 
-      DO jk = 4, jpkm1
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1
-               IF ( zhbl_t(ji,jj) >= gdepw_n(ji,jj,jk) ) THEN
-                  ibld(ji,jj) = jk
-               ENDIF
-            END DO
-         END DO
-      END DO
+
+      DO_3D_00_00( 4, jpkm1 )
+         IF ( zhbl_t(ji,jj) >= gdepw(ji,jj,jk,Kmm) ) THEN
+            ibld(ji,jj) = jk
+         ENDIF
+      END_3D
 
 !
 ! Step through model levels taking account of buoyancy change to determine the effect on dhdt
 !
-      CALL zdf_osm_timestep_hbl( zdhdt, zdhdt_2 )
+      CALL zdf_osm_timestep_hbl( zdhdt, zdhdt_2, Kmm )
       ! Alan: do we need zb_ml?
-      CALL zdf_osm_vertical_average( ibld, zt_bl, zs_bl, zu_bl, zv_bl, zdt_bl, zds_bl, zdb_bl, zdu_bl, zdv_bl )
+      CALL zdf_osm_vertical_average( ibld, zt_bl, zs_bl, zu_bl, zv_bl, zdt_bl, zds_bl, zdb_bl, zdu_bl, zdv_bl, Kmm, Kbb )
 !
 !
-      CALL zdf_osm_pycnocline_thickness( dh, zdh )
+      CALL zdf_osm_pycnocline_thickness( dh, zdh, Kmm )
       dstokes(:,:) = MIN ( dstokes(:,:), hbl(:,:)/3. )  !  Limit delta for shallow boundary layers for calculating flux-gradient terms.
 !
     ! Average over the depth of the mixed layer in the convective boundary layer
     ! Alan: do we need zb_ml?
-    CALL zdf_osm_vertical_average( imld, zt_ml, zs_ml, zu_ml, zv_ml, zdt_ml, zds_ml, zdb_ml, zdu_ml, zdv_ml )
+    CALL zdf_osm_vertical_average( imld, zt_ml, zs_ml, zu_ml, zv_ml, zdt_ml, zds_ml, zdb_ml, zdu_ml, zdv_ml, Kmm, Kbb )
     ! rotate mean currents and changes onto wind align co-ordinates
     !
@@ -564,24 +544,22 @@
      zwth_ent = 0._wp
      zws_ent = 0._wp
-     DO jj = 2, jpjm1
-        DO ji = 2, jpim1
-           IF ( ibld(ji,jj) < mbkt(ji,jj) ) THEN
-              IF ( lconv(ji,jj) ) THEN
-         	 zuw_bse(ji,jj) = -0.0075*((zvstr(ji,jj)**3+0.5*zwstrc(ji,jj)**3)**pthird*zdu_ml(ji,jj) + &
-                      &                    1.5*zustar(ji,jj)**2*(zhbl(ji,jj)-zhml(ji,jj)) )/ &
-                      &                     ( zhml(ji,jj)*MIN(zla(ji,jj)**(8./3.),1.) + epsln)
-	         zvw_bse(ji,jj) = 0.01*(-(zvstr(ji,jj)**3+0.5*zwstrc(ji,jj)**3)**pthird*zdv_ml(ji,jj)+ &
-                      &                    2.0*ff_t(ji,jj)*zustke(ji,jj)*dstokes(ji,jj)*zla(ji,jj))
-                 IF ( zdb_ml(ji,jj) > 0._wp ) THEN
-                    zwth_ent(ji,jj) = zwb_ent(ji,jj) * zdt_ml(ji,jj) / (zdb_ml(ji,jj) + epsln)
-                    zws_ent(ji,jj) = zwb_ent(ji,jj) * zds_ml(ji,jj) / (zdb_ml(ji,jj) + epsln)
-                 ENDIF
-              ELSE
-                 zwth_ent(ji,jj) = -2.0 * zwthav(ji,jj) * ( (1.0 - 0.8) - ( 1.0 - 0.8)**(3.0/2.0) )
-                 zws_ent(ji,jj) = -2.0 * zwsav(ji,jj) * ( (1.0 - 0.8 ) - ( 1.0 - 0.8 )**(3.0/2.0) )
+     DO_2D_00_00
+        IF ( ibld(ji,jj) < mbkt(ji,jj) ) THEN
+           IF ( lconv(ji,jj) ) THEN
+      	 zuw_bse(ji,jj) = -0.0075*((zvstr(ji,jj)**3+0.5*zwstrc(ji,jj)**3)**pthird*zdu_ml(ji,jj) + &
+                   &                    1.5*zustar(ji,jj)**2*(zhbl(ji,jj)-zhml(ji,jj)) )/ &
+                   &                     ( zhml(ji,jj)*MIN(zla(ji,jj)**(8./3.),1.) + epsln)
+              zvw_bse(ji,jj) = 0.01*(-(zvstr(ji,jj)**3+0.5*zwstrc(ji,jj)**3)**pthird*zdv_ml(ji,jj)+ &
+                   &                    2.0*ff_t(ji,jj)*zustke(ji,jj)*dstokes(ji,jj)*zla(ji,jj))
+              IF ( zdb_ml(ji,jj) > 0._wp ) THEN
+                 zwth_ent(ji,jj) = zwb_ent(ji,jj) * zdt_ml(ji,jj) / (zdb_ml(ji,jj) + epsln)
+                 zws_ent(ji,jj) = zwb_ent(ji,jj) * zds_ml(ji,jj) / (zdb_ml(ji,jj) + epsln)
               ENDIF
+           ELSE
+              zwth_ent(ji,jj) = -2.0 * zwthav(ji,jj) * ( (1.0 - 0.8) - ( 1.0 - 0.8)**(3.0/2.0) )
+              zws_ent(ji,jj) = -2.0 * zwsav(ji,jj) * ( (1.0 - 0.8 ) - ( 1.0 - 0.8 )**(3.0/2.0) )
            ENDIF
-        END DO
-     END DO
+        ENDIF
+     END_2D
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
@@ -589,80 +567,76 @@
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 
-      CALL zdf_osm_external_gradients( zdtdz_ext, zdsdz_ext, zdbdz_ext )
-      CALL zdf_osm_pycnocline_scalar_profiles( zdtdz_pyc, zdsdz_pyc, zdbdz_pyc )
-      CALL zdf_osm_pycnocline_shear_profiles( zdudz_pyc, zdvdz_pyc )
+      CALL zdf_osm_external_gradients( zdtdz_ext, zdsdz_ext, zdbdz_ext, Kmm )
+      CALL zdf_osm_pycnocline_scalar_profiles( zdtdz_pyc, zdsdz_pyc, zdbdz_pyc, Kmm )
+      CALL zdf_osm_pycnocline_shear_profiles( zdudz_pyc, zdvdz_pyc, Kmm )
        !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        ! Eddy viscosity/diffusivity and non-gradient terms in the flux-gradient relationship
        !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 
-       DO jj = 2, jpjm1
-          DO ji = 2, jpim1
-             IF ( lconv(ji,jj) ) THEN
-               zdifml_sc(ji,jj) = zhml(ji,jj) * ( zvstr(ji,jj)**3 + 0.5 * zwstrc(ji,jj)**3 )**pthird
-               zvisml_sc(ji,jj) = zdifml_sc(ji,jj)
-               zdifpyc_sc(ji,jj) = 0.165 * ( zvstr(ji,jj)**3 + 0.5 *zwstrc(ji,jj)**3 )**pthird * zdh(ji,jj)
-               zvispyc_sc(ji,jj) = 0.142 * ( zvstr(ji,jj)**3 + 0.5 * zwstrc(ji,jj)**3 )**pthird * zdh(ji,jj)
-               zbeta_d_sc(ji,jj) = 1.0 - (0.165 / 0.8 * zdh(ji,jj) / zhbl(ji,jj) )**p2third
-               zbeta_v_sc(ji,jj) = 1.0 -  2.0 * (0.142 /0.375) * zdh(ji,jj) / ( zhml(ji,jj) + epsln )
-             ELSE
-               zdifml_sc(ji,jj) = zvstr(ji,jj) * zhbl(ji,jj) * EXP ( -( zhol(ji,jj) / 0.6_wp )**2 )
-               zvisml_sc(ji,jj) = zvstr(ji,jj) * zhbl(ji,jj) * EXP ( -( zhol(ji,jj) / 0.6_wp )**2 )
-             END IF
-          END DO
-       END DO
+       DO_2D_00_00
+          IF ( lconv(ji,jj) ) THEN
+            zdifml_sc(ji,jj) = zhml(ji,jj) * ( zvstr(ji,jj)**3 + 0.5 * zwstrc(ji,jj)**3 )**pthird
+            zvisml_sc(ji,jj) = zdifml_sc(ji,jj)
+            zdifpyc_sc(ji,jj) = 0.165 * ( zvstr(ji,jj)**3 + 0.5 *zwstrc(ji,jj)**3 )**pthird * zdh(ji,jj)
+            zvispyc_sc(ji,jj) = 0.142 * ( zvstr(ji,jj)**3 + 0.5 * zwstrc(ji,jj)**3 )**pthird * zdh(ji,jj)
+            zbeta_d_sc(ji,jj) = 1.0 - (0.165 / 0.8 * zdh(ji,jj) / zhbl(ji,jj) )**p2third
+            zbeta_v_sc(ji,jj) = 1.0 -  2.0 * (0.142 /0.375) * zdh(ji,jj) / ( zhml(ji,jj) + epsln )
+          ELSE
+            zdifml_sc(ji,jj) = zvstr(ji,jj) * zhbl(ji,jj) * EXP ( -( zhol(ji,jj) / 0.6_wp )**2 )
+            zvisml_sc(ji,jj) = zvstr(ji,jj) * zhbl(ji,jj) * EXP ( -( zhol(ji,jj) / 0.6_wp )**2 )
+         END IF
+       END_2D
 !
-       DO jj = 2, jpjm1
-          DO ji = 2, jpim1
-             IF ( lconv(ji,jj) ) THEN
-                DO jk = 2, imld(ji,jj)   ! mixed layer diffusivity
-                    zznd_ml = gdepw_n(ji,jj,jk) / zhml(ji,jj)
+       DO_2D_00_00
+          IF ( lconv(ji,jj) ) THEN
+             DO jk = 2, imld(ji,jj)   ! mixed layer diffusivity
+                 zznd_ml = gdepw(ji,jj,jk,Kmm) / zhml(ji,jj)
+                 !
+                 zdiffut(ji,jj,jk) = 0.8   * zdifml_sc(ji,jj) * zznd_ml * ( 1.0 - zbeta_d_sc(ji,jj) * zznd_ml    )**1.5
+                 !
+                 zviscos(ji,jj,jk) = 0.375 * zvisml_sc(ji,jj) * zznd_ml * ( 1.0 - zbeta_v_sc(ji,jj) * zznd_ml    ) &
+                      &            *                                      ( 1.0 -               0.5 * zznd_ml**2 )
+             END DO
+             ! pycnocline - if present linear profile
+             IF ( zdh(ji,jj) > 0._wp ) THEN
+                zgamma_b = 6.0
+                DO jk = imld(ji,jj)+1 , ibld(ji,jj)
+                    zznd_pyc = -( gdepw(ji,jj,jk,Kmm) - zhml(ji,jj) ) / zdh(ji,jj)
                     !
-                    zdiffut(ji,jj,jk) = 0.8   * zdifml_sc(ji,jj) * zznd_ml * ( 1.0 - zbeta_d_sc(ji,jj) * zznd_ml    )**1.5
+                    zdiffut(ji,jj,jk) = zdifpyc_sc(ji,jj) * EXP( zgamma_b * zznd_pyc )
                     !
-                    zviscos(ji,jj,jk) = 0.375 * zvisml_sc(ji,jj) * zznd_ml * ( 1.0 - zbeta_v_sc(ji,jj) * zznd_ml    ) &
-                         &            *                                      ( 1.0 -               0.5 * zznd_ml**2 )
+                    zviscos(ji,jj,jk) = zvispyc_sc(ji,jj) * EXP( zgamma_b * zznd_pyc )
                 END DO
-                ! pycnocline - if present linear profile
-                IF ( zdh(ji,jj) > 0._wp ) THEN
-                   zgamma_b = 6.0
-                   DO jk = imld(ji,jj)+1 , ibld(ji,jj)
-                       zznd_pyc = -( gdepw_n(ji,jj,jk) - zhml(ji,jj) ) / zdh(ji,jj)
-                       !
-                       zdiffut(ji,jj,jk) = zdifpyc_sc(ji,jj) * EXP( zgamma_b * zznd_pyc )
-                       !
-                       zviscos(ji,jj,jk) = zvispyc_sc(ji,jj) * EXP( zgamma_b * zznd_pyc )
-                   END DO
-                   IF ( ibld_ext == 0 ) THEN
-                       zdiffut(ji,jj,ibld(ji,jj)) = 0._wp
-                       zviscos(ji,jj,ibld(ji,jj)) = 0._wp
-                   ELSE
-                       zdiffut(ji,jj,ibld(ji,jj)) = zdhdt(ji,jj) * ( hbl(ji,jj) - gdepw_n(ji, jj, ibld(ji,jj)-1) )
-                       zviscos(ji,jj,ibld(ji,jj)) = zdhdt(ji,jj) * ( hbl(ji,jj) - gdepw_n(ji, jj, ibld(ji,jj)-1) )
-                   ENDIF
-                ENDIF
-                ! Temporary fix to ensure zdiffut is +ve; won't be necessary with wn taken out
-                zdiffut(ji,jj,ibld(ji,jj)) = MAX(zdhdt(ji,jj) * e3t_n(ji,jj,ibld(ji,jj)), 1.e-6)
-                zviscos(ji,jj,ibld(ji,jj)) = MAX(zdhdt(ji,jj) * e3t_n(ji,jj,ibld(ji,jj)), 1.e-5)
-                ! could be taken out, take account of entrainment represents as a diffusivity
-                ! should remove w from here, represents entrainment
-             ELSE
-             ! stable conditions
-                DO jk = 2, ibld(ji,jj)
-                   zznd_ml = gdepw_n(ji,jj,jk) / zhbl(ji,jj)
-                   zdiffut(ji,jj,jk) = 0.75 * zdifml_sc(ji,jj) * zznd_ml * ( 1.0 - zznd_ml )**1.5
-                   zviscos(ji,jj,jk) = 0.375 * zvisml_sc(ji,jj) * zznd_ml * (1.0 - zznd_ml) * ( 1.0 - zznd_ml**2 )
-                END DO
-
                 IF ( ibld_ext == 0 ) THEN
                    zdiffut(ji,jj,ibld(ji,jj)) = 0._wp
                    zviscos(ji,jj,ibld(ji,jj)) = 0._wp
                 ELSE
-                   zdiffut(ji,jj,ibld(ji,jj)) = MAX(zdhdt(ji,jj), 0._wp) * e3w_n(ji, jj, ibld(ji,jj))
-                   zviscos(ji,jj,ibld(ji,jj)) = MAX(zdhdt(ji,jj), 0._wp) * e3w_n(ji, jj, ibld(ji,jj))
+                   zdiffut(ji,jj,ibld(ji,jj)) = zdhdt(ji,jj) * ( hbl(ji,jj) - gdepw(ji, jj, ibld(ji,jj)-1, Kmm) )
+                   zviscos(ji,jj,ibld(ji,jj)) = zdhdt(ji,jj) * ( hbl(ji,jj) - gdepw(ji, jj, ibld(ji,jj)-1, Kmm) )
                 ENDIF
-             ENDIF   ! end if ( lconv )
-             !
-          END DO  ! end of ji loop
-       END DO     ! end of jj loop
+             ENDIF
+             ! Temporary fix to ensure zdiffut is +ve; won't be necessary with ww taken out
+             zdiffut(ji,jj,ibld(ji,jj)) = MAX(zdhdt(ji,jj) * e3t(ji,jj,ibld(ji,jj), Kmm), 1.e-6)
+             zviscos(ji,jj,ibld(ji,jj)) = MAX(zdhdt(ji,jj) * e3t(ji,jj,ibld(ji,jj), Kmm), 1.e-5)
+             ! could be taken out, take account of entrainment represents as a diffusivity
+             ! should remove w from here, represents entrainment
+          ELSE
+          ! stable conditions
+             DO jk = 2, ibld(ji,jj)
+                zznd_ml = gdepw(ji,jj,jk, Kmm) / zhbl(ji,jj)
+                zdiffut(ji,jj,jk) = 0.75 * zdifml_sc(ji,jj) * zznd_ml * ( 1.0 - zznd_ml )**1.5
+                zviscos(ji,jj,jk) = 0.375 * zvisml_sc(ji,jj) * zznd_ml * (1.0 - zznd_ml) * ( 1.0 - zznd_ml**2 )
+             END DO
+
+             IF ( ibld_ext == 0 ) THEN
+                zdiffut(ji,jj,ibld(ji,jj)) = 0._wp
+                zviscos(ji,jj,ibld(ji,jj)) = 0._wp
+             ELSE
+                zdiffut(ji,jj,ibld(ji,jj)) = MAX(zdhdt(ji,jj), 0._wp) * e3w(ji, jj, ibld(ji,jj), Kmm)
+                zviscos(ji,jj,ibld(ji,jj)) = MAX(zdhdt(ji,jj), 0._wp) * e3w(ji, jj, ibld(ji,jj), Kmm)
+             ENDIF
+          ENDIF   ! end if ( lconv )
+          !
+       END_2D
 
        !
@@ -681,27 +655,25 @@
 
 
-       DO jj = 2, jpjm1
-          DO ji = 2, jpim1
-            IF ( lconv(ji,jj) ) THEN
-              DO jk = 2, imld(ji,jj)
-                 zznd_d = gdepw_n(ji,jj,jk) / dstokes(ji,jj)
-                 ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 1.35 * EXP ( -zznd_d ) * ( 1.0 - EXP ( -2.0 * zznd_d ) ) * zsc_wth_1(ji,jj)
-                 !
-                 ghams(ji,jj,jk) = ghams(ji,jj,jk) + 1.35 * EXP ( -zznd_d ) * ( 1.0 - EXP ( -2.0 * zznd_d ) ) *  zsc_ws_1(ji,jj)
-              END DO ! end jk loop
-            ELSE     ! else for if (lconv)
+       DO_2D_00_00
+         IF ( lconv(ji,jj) ) THEN
+           DO jk = 2, imld(ji,jj)
+              zznd_d = gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+              ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 1.35 * EXP ( -zznd_d ) * ( 1.0 - EXP ( -2.0 * zznd_d ) ) * zsc_wth_1(ji,jj)
+              !
+              ghams(ji,jj,jk) = ghams(ji,jj,jk) + 1.35 * EXP ( -zznd_d ) * ( 1.0 - EXP ( -2.0 * zznd_d ) ) *  zsc_ws_1(ji,jj)
+           END DO ! end jk loop
+         ELSE     ! else for if (lconv)
  ! Stable conditions
-               DO jk = 2, ibld(ji,jj)
-                  zznd_d=gdepw_n(ji,jj,jk) / dstokes(ji,jj)
-                  ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 1.5 * EXP ( -0.9 * zznd_d ) &
-                       &          *                 ( 1.0 - EXP ( -4.0 * zznd_d ) ) * zsc_wth_1(ji,jj)
-                  !
-                  ghams(ji,jj,jk) = ghams(ji,jj,jk) + 1.5 * EXP ( -0.9 * zznd_d ) &
-                       &          *                 ( 1.0 - EXP ( -4.0 * zznd_d ) ) *  zsc_ws_1(ji,jj)
-               END DO
-            ENDIF               ! endif for check on lconv
-
-          END DO  ! end of ji loop
-       END DO     ! end of jj loop
+            DO jk = 2, ibld(ji,jj)
+               zznd_d=gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+               ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 1.5 * EXP ( -0.9 * zznd_d ) &
+                    &          *                 ( 1.0 - EXP ( -4.0 * zznd_d ) ) * zsc_wth_1(ji,jj)
+               !
+               ghams(ji,jj,jk) = ghams(ji,jj,jk) + 1.5 * EXP ( -0.9 * zznd_d ) &
+                    &          *                 ( 1.0 - EXP ( -4.0 * zznd_d ) ) *  zsc_ws_1(ji,jj)
+            END DO
+         ENDIF               ! endif for check on lconv
+
+       END_2D
 
 ! Stokes term in flux-gradient relationship (note in zsc_uw_n don't use zvstr since term needs to go to zero as zwstrl goes to zero)
